//  ************* TinyFlea user demo example - c source  ***********
//  **   Provides users with a starting point towards building      
//  ** their own applications based on Fleatiny's sowftare framework
//  **                                                               
//  ** Question: What does this example code do?                     
//  ** Answer: It's a simple console test app that accepts 
//  ** keystrokes from the PS/2 keyboard and displays them 
//  ** to the VGA screen. 
//  ** Assuming a suitable SD card is installed, pressing either '+' or 
//  ** '-' Keys will either save or restore the current screen text 
//  ** to/from the raw sector #1 on the SD card

//  ** Please direct any questions you may have regarding this      
//  ** software to <http://www.fleasystems.com/forums/> - Enjoy! }:A      
//  **                                                              
//  ** Written by: Valentin Angelovski   Date: 11/12/2012          
//  **                                                              
//  ** Note: This software is freeware - use it at your own risk!   
//  ****************************************************************


//  ******** Routine to fetch one screen of videotext data (512 Bytes) 
//  ******** from raw sector #1 of the SD card and store it in the videotext buffer
void load_textbuffer(void)
{
// load in data from the SD card 
	sd_sector_read = 1;	
	sd_iosector(1);	
	
 // Transfer data from SD_buffer to videotext buffer
	for(dataptr=0;dataptr<512;dataptr++)
	{
		VRAM[dataptr] = sd_buffer[dataptr]+10; 
	}
}


//  ******** Routine to fetch one screen of videotext data (512 Bytes) 
//  ******** from the videotext buffer and store it in raw sector #1 of the SD card 
void save_textbuffer(void)
{ 
// Transfer data from videotext buffer to SD_buffer
	for(dataptr=0;dataptr<512;dataptr++)
	{
		sd_buffer[dataptr] = VRAM[dataptr] - 10;
	}
	
// Save data to SD card 
	sd_sector_read = 0;
	sd_iosector(1);
}


//  ******** Routine to fill the videotext buffer with whitespaces (i.e. clear the screen)
void clear_textbuffer(void)
{
	for(dataptr=0;dataptr<512;dataptr++)
	{
		VRAM[dataptr] = ' '+10;
	}
}



//  ******** Main program code begins here! *********

void userprg(void) 
{
	unsigned char myvariable; // Temporary user variable

	clear_textbuffer(); // Clear VGA videotext screen
	
	temp1 = sd_init(); // Init SD card 
	
tick_timer = 200;	// Fleatiny system timer delay loop (200 x 0.0167 = 3.33 seconds)
repeatzz:
if(tick_timer > 0) goto repeatzz;

tick_timer = 200;	// Fleatiny system timer delay loop (200 x 0.0167 = 3.33 seconds)
repeatz2:
if(tick_timer > 0) goto repeatz2;

PS2_GOTK = 0;




myvariable=0;		

// *** Prints a welcome message to the screen
	while (welcome_msg[myvariable] != 0) // Checks for null-terminator at the end of the welcome message
	{
		newchar = welcome_msg[myvariable]; // Sends out message to TTY console_out, one character at a time..
		tty_outchar();
		myvariable++;
	}
	
newchar=0;


// *** Console handler begins here (basically an endless loop.. :-)
myvariable=0;		
	while (1)
	{
		tty_inchar();			// Loop here endlessly until a character is received from the PS/2 keyboard
		if(newchar != 0)
		{
			tty_outchar();		// Insert a line-feed character if the ENTER key is pressed by the user
			if(newchar == 13)
			{
				newchar = 10;
				tty_outchar();
			}
			
			if(newchar == '+')	// If '+' Key pressed, save current videotext screen data to the SD card
			{
				save_textbuffer(); // 
			}

			if(newchar == '-')	// If '-' Key pressed, load new videotext screen data from the SD card
			{
				load_textbuffer();
			}			
			newchar = 0;
			}
		}
}