/*-------------------------------------------------------------------------
   I/O Pin register declaration for the Fleatiny embedded platform

   Written By -  Valentin Angelovski (December 2012)


  This file is part of my Fleatiny embedded framework. Please refer 
  to <http://www.fleasystems.com/fleatiny.html> for further info.

  Fleatiny embedded framework is free software: you can redistribute it and/or 
  modify it under the terms of the GNU Lesser General Public License as published 
  by the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Fleatiny embedded framework is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with Fleatiny embedded framework.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------*/


/*  BYTE Register  */

__sfr __at (0xA0) TINYBUS ;


/*  BIT Register  */

/******************* Fleatiny P0 bits ********************/
__sbit __at (0x80) IO1 ;
__sbit __at (0x81) IO2 ;
__sbit __at (0x82) IO3 ;
__sbit __at (0x83) IO4 ;
__sbit __at (0x84) IO5 ;
__sbit __at (0x85) IO6 ;
__sbit __at (0x86) IO7 ;
__sbit __at (0x87) IO8 ;


/****************** Fleatiny P1 bits ********************/
__sbit __at (0x90) VGA_TOGGL ;
__sbit __at (0x91) VGA_ENABL ;
__sbit __at (0x92) DAC_BIT0 ;
__sbit __at (0x93) DAC_BIT1 ;
__sbit __at (0x94) SD_CS ;
__sbit __at (0x95) SD_MOSI ;
__sbit __at (0x96) SD_MISO ;
__sbit __at (0x97) SD_CLK ;


/****************** Fleatiny P2 bits ********************/
__sbit __at (0xA0) SQI_MOSI ;
__sbit __at (0xA1) TINYBUS1;
__sbit __at (0xA2) TINYBUS2;
__sbit __at (0xA3) TINYBUS3;
__sbit __at (0xA4) UPNIB4_SQICK ;
__sbit __at (0xA5) UPNIB5;
__sbit __at (0xA6) UPNIB6;
__sbit __at (0xA7) UPNIB7;


/******************  Fleatiny P3 bits ********************/
__sbit __at (0xB0) UART_RXD ;
__sbit __at (0xB1) UART_TXD ;
__sbit __at (0xB2) KBDDIN ;
__sbit __at (0xB3) KBDCKI ;
__sbit __at (0xB4) SQI_CS ;
__sbit __at (0xB5) STC_CLKOUT;
__sbit __at (0xB6) VSYNC ;
__sbit __at (0xB7) HSYNC ;
